#ifndef APPSWIDGET_H
#define APPSWIDGET_H

#include <QVBoxLayout>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QPixmap>
#include <QLabel>
#include <QScrollArea>
#include <QSettings>
#include <QMimeData>

#include "iconview.h"
#include "application.h"
#include "appsmodel.h"
#include "settings.h"

class AppsWidget : public IconView
{
	Q_OBJECT

	public:
		AppsWidget(QWidget * parent = 0);

	public slots:
		void updateApps();
		void doubleClicked(QModelIndex index);
		void loadIconPositions();

	signals:
		void launchApplication(Application *);

	protected:
		void dropEvent(QDropEvent* e);

	private slots:
		void saveIconPositions();

	private:
		void init();
		void addApplication(Application * app);

		AppsModel * model;
};

#endif
