QT += core gui widgets network multimedia multimediawidgets
QT += webenginewidgets

linux: QT += x11extras dbus
freebsd: QT += x11extras dbus
win32: QT += winextras

win32: system( xcopy /i /y ..\..\..\liblwnet liblwnet )

DEFINES += UNICODE
freebsd: DEFINES += Q_OS_LINUX

linux: TEMPLATE = lib
freebsd: TEMPLATE = lib
win32: TEMPLATE = app

LANGUAGE        = C++

linux: LIBS += -lX11 -lXrandr -lcups -lldap -lpam -llibrework-client
unix: LIBS += -lX11 -lXrandr -llibrework-client
win32: LIBS += -lpsapi -ladvapi32 -lwtsapi32 -lmpr -lnetapi32 -luser32 -lshell32 -lcomdlg32 -luuid -lole32 -lws2_32 -lcrypt32

linux: extraclean.commands = rm -rf liblwnet
win32: extraclean.commands = rmdir /s /q liblwnet

distclean.depends = extraclean

build.target = liblwnet
linux: build.commands  = cp -a ../../../liblwnet .
win32: build.commands  = xcopy /i /y ..\..\..\liblwnet liblwnet

PRE_TARGETDEPS += liblwnet

QMAKE_EXTRA_TARGETS += distclean extraclean build

include(../qmake.variables)

HEADERS += application.h appserver.h appsmodel.h appswidget.h \
    splitter.h \
    filesystemmodel.h \
    filethread.h \
    filethreadwidget.h \
    listview.h \
    power.h \
    remoteappserver.h
HEADERS += closebutton.h cloudconfig.h cloudconfigwizard.h cloudconfigwizardpage.h cloudinterface.h
HEADERS += configurationdialog.h configure.h constants.h clipboardfiles.h
HEADERS += displayconfig.h desktop.h dragdrop.h libreworkdesktopinterface.h
HEADERS += fileiconprovider.h fileproperties.h filesystemitem.h filesystemwidget.h fontsconfig.h
HEADERS += initprogress.h initscreen.h
HEADERS += languageconfig.h iconview.h iconviewitemdelegate.h lwclient.h lwlocale.h
HEADERS += manager.h menu.h mime.h mimeconfig.h
HEADERS += pixmapframe.h pixmaplabel.h placesmodel.h placeswidget.h
HEADERS += remoteclientmanager.h
HEADERS += searchlineedit.h sessionmanager.h settings.h sharedesktopconfig.h
HEADERS += storageservice.h systrayclient.h systraymanager.h systraywidget.h
HEADERS += tabbar.h tablewidget.h threadbutton.h threadmanager.h threadwidget.h toolbutton.h tooltip.h
HEADERS += touchconfig.h userconfig.h
HEADERS += wininfo.h winaction.h winmanager.h
HEADERS += liblwnet/lwconstants.h liblwnet/lwerrors.h liblwnet/lwsocket.h
linux {
	HEADERS += cupsmanager.h ldapinfo.h
}

SOURCES += application.cpp appserver.cpp appsmodel.cpp appswidget.cpp \
    splitter.cpp \
    filesystemmodel.cpp \
    filethread.cpp \
    filethreadwidget.cpp \
    listview.cpp \
    power.cpp \
    remoteappserver.cpp
SOURCES += closebutton.cpp cloudconfig.cpp cloudconfigwizard.cpp cloudconfigwizardpage.cpp cloudinterface.cpp
SOURCES += configure.cpp clipboardfiles.cpp
SOURCES += displayconfig.cpp desktop.cpp dragdrop.cpp libreworkdesktopinterface.cpp
SOURCES += fileiconprovider.cpp fileproperties.cpp filesystemitem.cpp filesystemwidget.cpp fontsconfig.cpp
SOURCES += initprogress.cpp initscreen.cpp
SOURCES += languageconfig.cpp iconview.cpp iconviewitemdelegate.cpp lwclient.cpp lwlocale.cpp
SOURCES += manager.cpp menu.cpp mime.cpp mimeconfig.cpp
SOURCES += pixmapframe.cpp pixmaplabel.cpp placesmodel.cpp placeswidget.cpp
SOURCES += remoteclientmanager.cpp
SOURCES += searchlineedit.cpp sessionmanager.cpp settings.cpp sharedesktopconfig.cpp
SOURCES += storageservice.cpp systrayclient.cpp systraymanager.cpp systraywidget.cpp
SOURCES += tabbar.cpp tablewidget.cpp threadbutton.cpp threadmanager.cpp threadwidget.cpp toolbutton.cpp tooltip.cpp
SOURCES += touchconfig.cpp userconfig.cpp
SOURCES += wininfo.cpp winaction.cpp winmanager.cpp
SOURCES += liblwnet/lwsocket.cpp
linux {
	SOURCES += ldapinfo.cpp cupsmanager.cpp
}
win32 {
        SOURCES += main.cpp
}

TARGET		= librework-desktop
target.path	= $$LIB_DIR
target.depends	= build
INSTALLS        += target

linux: exists( "/usr/bin/colorgcc" ) {
	QMAKE_CXX = colorgcc
}

RESOURCES += \
    resources.qrc

FORMS += \
    filesystemwidget.ui \
    initscreen.ui \
    initprogress.ui \
    menu.ui \
    fileproperties.ui
