#ifndef DISPLAYCONFIG_H
#define DISPLAYCONFIG_H

#include <QObject>
#include <QMessageBox>
#include <QApplication>
#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QLineEdit>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QList>
#include <QLabel>
#include <QPushButton>
#include <QComboBox>
#include <QCheckBox>
#include <QProcess>
#include <QHBoxLayout>
#include <QDir>

#include "configurationdialog.h"
#include "settings.h"

class DisplayConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		DisplayConfig(QWidget * parent);

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "displayconfig.png"); };
		QString name() { return tr("Display configuration"); };
		QDialog * widget() { return this; };

	public slots:
		void accept();
		void reject();

	private:
		void readDisplay();
		void loadSettings();
		void saveSettings();

		QGridLayout * layout;

		QGroupBox * monitorsGroup;
		QList<QPushButton *> monitors;
		QCheckBox * isPrimary;
		QCheckBox * isActive;
		QComboBox * resolutions;
		QPushButton * acceptButton;
		QPushButton * cancelButton;

		QStringList monitorList;
		QStringList monitorId;
		QStringList monitorName;
		QList<bool> monitorActive;
		int primaryMonitorIndex;
};

#endif
