#ifndef FILESYSTEMITEM_H
#define FILESYSTEMITEM_H

#include <QString>
#include <QList>
#include <QMap>
#include <QVariant>
#include <QStringList>
#include <QFileSystemModel>

class FileSystemItem
{
public:
	FileSystemItem( FileSystemItem * parent = nullptr, QFileSystemModel * itemModel = nullptr );
	~FileSystemItem();

	FileSystemItem * parent();
	QFileSystemModel * model();

	QList<FileSystemItem*> children();
	void appendChild( FileSystemItem * child );

	QVariant itemData(int role);
	QVariant setItemData(QVariant value, int role);

	QStringList tags();
	void appendTag( QString tag );


private:
	FileSystemItem * _parent;
	QList<FileSystemItem*> _children;
	QMap<int,QVariant> _itemData;
	QStringList _tags;
	QFileSystemModel * _itemModel;
};

#endif
