#include "filesystemmodel.h"

FileSystemModel::FileSystemModel(QWidget * parent, bool onlyShowDirs) : QFileSystemModel(parent)
{
	this->_parent = parent;
	iconProvider = new FileIconProvider;

	this->setResolveSymlinks( false );
	this->setIconProvider( iconProvider );
	if ( onlyShowDirs )
	{
		this->setFilter(QDir::Dirs);
	}

	//connect( this, SIGNAL(directoryLoaded(QString)), this, SIGNAL(directoryLoaded(QString)) );
	//connect( this, SIGNAL(rootPathChanged(QString)), this, SIGNAL(rootPathChanged(QString)) );

	//initModel();
}

/*void FileSystemModel::initModel()
{
	rootItem = new FileSystemItem;

	QSettings fileSettings( CONF_DIR "filesystemitems.ini", QSettings::IniFormat );
	QStringList itemList = fileSettings.childGroups();

	QMap<QString,FileSystemItem*> root;
	for ( int i = 0; i < itemList.count(); i++ )
	{
		QString itemType = fileSettings.value( itemList[i] ).toString();
		if ( itemType.toLower() == "root" )
		{
			QString name = LWLocale::getLocalizedValue( fileSettings, itemList[i] + "/name" );
			QString iconString = fileSettings.value( itemList[i] + "/" + "icon" ).toString();
			QIcon icon = QIcon( ICON_DIR_128 + QString(QDir::separator()) + iconString );

			FileSystemItem * item = new FileSystemItem( rootItem );
			item->setItemData( name, Qt::DisplayRole );
			item->setItemData( icon, Qt::DecorationRole );
			item->setItemData( itemList[i], Qt::UserRole );
			root[itemList[i]] = item;
		}
	}
	QMap<QString,QString> tag;
	for ( int i = 0; i < itemList.count(); i++ )
	{
		QString itemType = fileSettings.value( itemList[i] ).toString();
		if ( itemType.toLower() == "tag" )
		{
			QString name = LWLocale::getLocalizedValue( fileSettings, itemList[i] + "/name" );
			tag[itemList[i]] = name;
		}
	}
	for ( int i = 0; i < itemList.count(); i++ )
	{
		QString itemType = fileSettings.value( itemList[i] ).toString();
		if ( itemType.toLower() == "directory" )
		{
			QString name = LWLocale::getLocalizedValue( fileSettings, itemList[i] + "/name" );
			QString parent = fileSettings.value( itemList[i] + "/parent" ).toString();
			QString tag = fileSettings.value( itemList[i] + "/tag" ).toString();
			if ( root.contains( parent ) )
			{
				QString iconString;
				iconString = fileSettings.value( itemList[i] + "/" + "icon" ).toString();
				QIcon icon = QIcon( ICON_DIR_128 + QString(QDir::separator()) + iconString );
				QFileSystemModel * itemModel = new QFileSystemModel( this );
				itemModel->setRootPath( itemList[i] );
				FileSystemItem * item = new FileSystemItem( root[parent], itemModel );
				item->setItemData( name, Qt::DisplayRole );
				item->setItemData( icon, Qt::DecorationRole );
				item->setItemData( itemList[i], Qt::UserRole );
				item->setItemData( tag, Qt::UserRole + 1 );
			}
		}
	}
}

QModelIndex FileSystemModel::index(int row, int column, const QModelIndex &parent) const
{
	if ( parent.model() == this )
	{

	} else {
		return fsModel->index( row, column, parent );
	}
}

QModelIndex FileSystemModel::parent(const QModelIndex &index) const
{
	return QModelIndex();
}

int FileSystemModel::rowCount(const QModelIndex &parent) const
{
	return 0;
}

int FileSystemModel::columnCount(const QModelIndex &parent) const
{
	return 0;
}

QVariant FileSystemModel::data(const QModelIndex &index, int role) const
{
	if ( index.model() == this )
	{
		QVariant ret;

		switch (role)
		{
			case Qt::DisplayRole:
				break;
			case Qt::DecorationRole:
				break;
			case Qt::EditRole:
				break;
			case Qt::ToolTipRole:
				break;
			case Qt::StatusTipRole:
				break;
			case Qt::WhatsThisRole:
				break;
			case Qt::SizeHintRole:
				break;
		}

		return ret;
	} else {
		return fsModel->data( index, role );
	}
}

bool FileSystemModel::hasChildren(const QModelIndex &parent) const
{
	return false;
}

QString FileSystemModel::filePath(const QModelIndex &index)
{
	return QString();
}

QString FileSystemModel::fileName(const QModelIndex &index)
{
	return QString();
}

QFileInfo FileSystemModel::fileInfo(const QModelIndex &index)
{
	return QFileInfo();
}

QString FileSystemModel::rootPath()
{
	return QString();
}

void FileSystemModel::setRootPath(const QString &rootPath)
{

}

QModelIndex FileSystemModel::index(const QString & fileName) const
{
	return QModelIndex();
}

void FileSystemModel::mkdir(const QModelIndex &index, const QString & dirName)
{
	if ( index.model() == this )
	{
		return;
	} else {
		fsModel->mkdir( index, dirName );
	}
}

void FileSystemModel::update()
{
#ifdef Q_OS_WIN
	QString rootpath = this->rootPath();
	fsModel->setRootPath( "" );
	fsModel->setRootPath( rootpath );
#endif
}*/

void FileSystemModel::copyFiles(QModelIndexList indexes, QFileInfo targetDir)
{
	if ( indexes.count() > 0 )
	{
		QFileInfoList fileList;
		for ( int i = 0; i < indexes.count(); i++ )
		{
			fileList.append( this->fileInfo( indexes[i] ) );
		}
		FileThread * fileThread = new FileThread( FileThread::COPY_FILES, nullptr, fileList, QDir( targetDir.absoluteFilePath() ) );
		connect( fileThread, SIGNAL(finished()), this, SLOT(update()));
		FileThreadWidget * fileThreadWidget = new FileThreadWidget( fileThread, nullptr );
		fileThreadWidget->show();
		fileThreadWidget->start();
	}
}

void FileSystemModel::moveFiles(QModelIndexList indexes, QFileInfo targetDir)
{
	if ( indexes.count() > 0 )
	{
		QFileInfoList fileList;
		for ( int i = 0; i < indexes.count(); i++ )
		{
			fileList.append( this->fileInfo( indexes[i] ) );
		}
		FileThread * fileThread = new FileThread( FileThread::MOVE_FILES, nullptr, fileList, QDir( targetDir.absoluteFilePath() ) );
		connect( fileThread, SIGNAL(finished()), this, SLOT(update()));
		FileThreadWidget * fileThreadWidget = new FileThreadWidget( fileThread, nullptr );
		fileThreadWidget->show();
		fileThreadWidget->start();
	}
}

void FileSystemModel::removeFiles(QModelIndexList selectedIndexes)
{
	QFileInfoList fileList;
	for ( int i = 0; i < selectedIndexes.count(); i++ )
	{
		fileList.append( this->fileInfo( selectedIndexes[i] ) );
	}
	FileThread * fileThread = new FileThread( FileThread::REMOVE_FILES, nullptr, fileList );
	connect( fileThread, SIGNAL(finished()), this, SLOT(update()));
	FileThreadWidget * fileThreadWidget = new FileThreadWidget( fileThread, nullptr );
	fileThreadWidget->show();
	fileThreadWidget->start();
}

void FileSystemModel::renameFile(QModelIndex selectedIndex, QString newName)
{
	QDir dir(this->rootPath());
	dir.rename( this->fileName( selectedIndex ), newName );
}

bool FileSystemModel::copyRecursively(QString sourceFile, QString targetFile)
{
	QFileInfo sourceFileInfo(sourceFile);
	if (sourceFileInfo.isDir())
	{
		QDir targetDir(targetFile);
		targetDir.cdUp();
		if ( ! targetDir.mkdir(QFileInfo(targetFile).fileName()))
		{
			return false;
		}
		QDir sourceDir(sourceFile);
		QStringList fileNames = sourceDir.entryList(QDir::Files | QDir::Dirs | QDir::NoDotAndDotDot | QDir::Hidden | QDir::System);
		foreach (const QString &fileName, fileNames)
		{
			const QString newSrcFilePath = sourceFile + QDir::separator() + fileName;
			const QString newTgtFilePath = targetFile + QDir::separator() + fileName;
			if (!copyRecursively(newSrcFilePath, newTgtFilePath))
			{
				return false;
			}
		}
	} else {
		QFile sourceQFile(sourceFile);
		QFile targetQFile(targetFile);
		QFile::Permissions permissions = sourceQFile.permissions();
		if ( ! QFile::copy(sourceFile, targetFile) )
		{
			return false;
		} else {
			targetQFile.setPermissions( permissions );
		}
	}
	return true;
}

QString FileSystemModel::findFile(QString searchString)
{
	QDirIterator it(this->rootPath(), QDirIterator::Subdirectories);
	while (it.hasNext())
	{
		it.next();
		if (it.fileName().contains( searchString, Qt::CaseInsensitive) )
		{
			return it.filePath();
		}
	}
	return QString();
}
