#ifndef FILESYSTEMMODEL_H
#define FILESYSTEMMODEL_H

#include <QObject>
#include <QFileSystemModel>
#include <QFileInfo>
#include <QAbstractItemModel>
#include <QModelIndex>
#include <QMutex>
#include <QList>

#include "fileiconprovider.h"
#include "filethread.h"
#include "filethreadwidget.h"
#include "filesystemitem.h"
#include "lwlocale.h"

//class FileSystemModel : public QAbstractItemModel
class FileSystemModel : public QFileSystemModel
{
	Q_OBJECT
public:
	FileSystemModel(QWidget *parent = 0, bool onlyShowDirs = false);

	/*void initModel();

	QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	int columnCount(const QModelIndex &parent = QModelIndex()) const;
	QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;
	bool hasChildren(const QModelIndex &parent = QModelIndex()) const;
	QModelIndex index(const QString & fileName) const;
	QModelIndex parent(const QModelIndex &index) const;

	QString fileName(const QModelIndex &index);
	QString filePath(const QModelIndex &index);
	QFileInfo fileInfo(const QModelIndex &index);
	QString rootPath();
	void setRootPath(const QString &rootPath);*/

	void copyFiles(QModelIndexList indexes, QFileInfo targetDir);
	void moveFiles(QModelIndexList indexes, QFileInfo targetDir);
	void removeFiles(QModelIndexList selectedIndexes);
	bool copyRecursively(QString sourceFile, QString targetFile);
	void renameFile(QModelIndex selectedIndex, QString newName);
	QString findFile(QString searchString);

	QWidget * parentWidget() { return _parent; };

/*signals:
	void rootPathChanged(QString);
	void directoryLoaded(QString);

public slots:
	void update();
*/

private:
	FileIconProvider * iconProvider;
	QWidget * _parent;
	QFileSystemModel * fsModel;
	//FileSystemItem * rootItem;
};

#endif // FILESYSTEMMODEL_H
