#ifndef ICONVIEWITEMDELEGATE_H
#define ICONVIEWITEMDELEGATE_H

#include <QItemDelegate>
#include <QFont>
#include <QPainter>
#include <QGraphicsColorizeEffect>
#include <QModelIndex>
#include <QPoint>

#include "settings.h"
#include "constants.h"

class IconViewItemDelegate : public QItemDelegate
{
public:
	IconViewItemDelegate(QObject *parent = 0);

	void setPressed(QPoint pos);
	void setSelectionShadow(bool selectionShadow);

	static QPixmap highlight(QPixmap pixmap);
	static QPixmap toGrayScale(QPixmap pixmap);
	static QPixmap fillBackground(QPixmap pixmap, QColor color);

protected:
	void drawDisplay(QPainter *painter, const QStyleOptionViewItem &option, const QRect &rect, const QString &text) const;
	void drawFocus(QPainter *painter, const QStyleOptionViewItem &option, const QRect &rect) const;
	void drawDecoration(QPainter *painter, const QStyleOptionViewItem &option, const QRect &rect, const QPixmap &pixmap) const;
	void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
	bool editorEvent(QEvent *event, QAbstractItemModel *model, const QStyleOptionViewItem &option, const QModelIndex &index);
	QSize sizeHint(const QStyleOptionViewItem &option, const QModelIndex &index) const;

private:
	QPoint pressedPos;
	bool selectionShadow;
};

#endif // ICONVIEWITEMDELEGATE_H
