#include "listview.h"

ListView::ListView(QWidget *parent) : QTreeView( parent )
{
	mimeFormat = "text/uri-list";

	setDropIndicatorShown( true );
	setDragDropMode( QAbstractItemView::DragDrop );
}

void ListView::dragEnterEvent(QDragEnterEvent* event)
{
	DragDrop::dragEnterEvent( event, mimeFormat );
}

void ListView::dragMoveEvent(QDragMoveEvent* e)
{
	DragDrop::dragMoveEvent( e, mimeFormat );
}

void ListView::dropEvent(QDropEvent* e)
{
	QPair<QStringList,QModelIndex> ret = DragDrop::dropEvent( e, this );
	if ( ret.first.count() > 0 )
	{
		emit dropFiles( ret.second, ret.first, e );
	}
}

void ListView::startDrag(Qt::DropActions supportedActions)
{
	DragDrop::startDrag( supportedActions, this, fileSystemMode );
}
