#ifndef LWCLIENT_H
#define LWCLIENT_H

#include <QObject>
#include <QString>
#include <QByteArray>
#include <QMutex>
#include <QThread>

#include "settings.h"
#include "liblwnet/lwsocket.h"

class LWClient
{
	public:
		LWClient();

		static LWClient * instance();

		bool connect(QString _address = QString(), int _port = -1);
		void close(bool sendQuit = true);
		bool authenticate(QString username, QString password);
		bool isConnected() { return _isConnected; }
		long long sendData(QByteArray data);
		QString sendMessage(QString message);
		QString sendMessage(QString command, QStringList parameters);
		QByteArray sendMessageByteArray(QString message);
		QByteArray sendMessageByteArray(QString command, QStringList parameters);

		SOCKET socket() { return tcpSocket; }

	private:
		SOCKET tcpSocket;
		bool _isConnected;
		bool _isAuthenticated;
		QMutex mutex;
};

#endif
