#ifndef APPBUTTON_H
#define APPBUTTON_H

#include <QPushButton>
#include <QPaintEvent>
#include <QString>
#include <QStringList>
#include <QIcon>
#include <QPixmap>
#include <QColor>
#include <QRgb>
#include <QPainter>
#include <QFont>
#include <QWidget>
#include <QSize>
#include <QGraphicsScene>
#include <QGraphicsColorizeEffect>
#include <QGraphicsPixmapItem>
#include <QCursor>

#include "constants.h"
#include "settings.h"
#include "application.h"

class AppButton : public QPushButton
{
	Q_OBJECT

	public:
		AppButton ( Application * app, QString fontColor, QWidget * parent = 0 );
		AppButton ( QIcon icon, QString name, QWidget * widget, QString fontColor, QWidget * parent = 0 );

		static QSize buttonSize();

		Application * getAppInstance() { return app; };

	signals:
		void appButtonClicked(Application * button);
		void appButtonClicked(QWidget * widget);

	private slots:
		void buttonClicked();

    private:
		bool event(QEvent *event);
        void enterEvent(QEvent * event);
        void leaveEvent(QEvent * event);
        void mousePressEvent(QMouseEvent * event);
        void mouseReleaseEvent(QMouseEvent * event);
		void paintEvent ( QPaintEvent * e);
        void forceRepaint();

		Application * app;
		QString text;
		QIcon icon;
		QWidget * widget;
        QWidget * parent;
        int substract;
        bool highlight;
		QString fontColor;
};

#endif
