#ifndef WININFO_H
#define WININFO_H

#include <QWidget>
#include <QString>
#include <QHash>
#include <QHashIterator>
#include <QDesktopWidget>
#include <QList>
#include <QProcess>
#include <QTimer>
#include <QString>
#include <QWindow>
#include <QGuiApplication>
#include <QApplication>
#include <QIcon>

#ifdef Q_OS_WIN
#include <WinSock2.h>
#include <windows.h>
#include <Psapi.h>
#include <lm.h>
#include <WtsApi32.h>
#include <QtWinExtras/QtWin>
//#include <qpa/qplatformnativeinterface.h>
#endif

#include "constants.h"
#include "settings.h"

#ifdef Q_OS_LINUX
#ifndef HWND
#define HWND long long
#endif

#ifndef DWORD
#define DWORD long
#endif
#endif

struct handleData
{
    QProcess * process;
    bool showVisible;
    QList<HWND> windows;
    HWND first;
};

/*
struct _STORAGE_DEVICE_NUMBER
{
  DEVICE_TYPE  DeviceType;
  ULONG  DeviceNumber;
  ULONG  PartitionNumber;
};
*/

#ifdef Q_OS_WIN
BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lparam);
BOOL CALLBACK FindWindowProc(HWND hWnd, LPARAM lparam);
//void CALLBACK FollowWindowsProc(HWINEVENTHOOK hook, DWORD event, HWND hWnd, long idObject, long idChild, DWORD dwEventThread, DWORD dwmsEventTime);
#endif

class WinInfo
{
    public:
        static void followProc(DWORD processId);
		//static QList<HWND> getWindows(QProcess * process);
		static HWND getWindow(QProcess * process);
        static QList<HWND> getVisibleWindows();
        static QString getWindowTitle(HWND hWnd);
        static unsigned long getWindowPid(HWND hWnd);
        static QString getWindowExecName(HWND hWnd);
        static HWND getParent(HWND hWnd);
		static bool hasNoParent(HWND hWnd);
		static void setWindowsInfo( QList<HWND> * windowsList, QList<long> * styles, QList<long> * exStyles, QList<QString> * titles, QList<unsigned long> * pids);
        static void debugWindowInfo( HWND hWnd );

#ifdef Q_OS_WIN
        static int isWindowStyle(HWND hWnd, long style);
        static int isWindowExStyle(HWND hWnd, long style);

        static bool isDlgFrame(HWND hWnd);
        static bool isChild(HWND hWnd);
        static bool isPopupWindow(HWND hWnd);
        static bool isPopup(HWND hWnd);
        static bool hasSysmenu(HWND hWnd);
        static bool isOverlapped(HWND hWnd);
        static bool isOverlappedWindow(HWND hWnd);
        static bool isVisible(HWND hWnd);
        static bool isAppWindow(HWND hWnd);
        static bool isToolWindow(HWND hWnd);
#endif

        static void selectWindow(HWND hWnd, bool fullScreen = false);
        static void closeWinWindow(HWND hWnd);
        static void killWinWindow(HWND hWnd);
        static void attachWindow(QWidget * container, HWND hWnd);
        static void hideTaskBar();
        static void showTaskBar();
        static QIcon getWindowIcon(HWND hwnd);
        static QIcon getAppIcon(QString command);
#ifdef Q_OS_WIN
		static void setWallPaper(LPWSTR image);
#endif

        static HWND fromId(long long id);
};

#endif // WININFO_H
