#ifndef PLACESMODEL_H
#define PLACESMODEL_H

#include <QObject>
#include <QStandardItemModel>
#include <QHash>
#include <QIcon>
#include <QFile>
#include <QDir>
#include <QFont>
#include <QMutex>

#include "remoteclientmanager.h"

class Place
{
public:
	Place(QIcon icon, QIcon fileManagerIcon, QString name, QString location = QString() );

	bool validate();

	QIcon icon;
	QIcon fileManagerIcon;
	QString name;
	QString location;
};

class PlacesModel : public QStandardItemModel
{
	Q_OBJECT
public:
	PlacesModel(QObject *parent = nullptr, bool isFileManager = false, QFont placesFont = QFont());
	~PlacesModel();

	void updatePlaces(RemoteClientManager *remoteClientManager = nullptr);
	void appendItem(Place * place);
	Place * getItem(QModelIndex index);
	void removeIndex(QModelIndex index);
	void clear();

private:
	QHash<QString,Place*> places;
	QFont placesFont;
	QMutex mutex;
	bool isFileManager;
};

#endif // PLACESMODEL_H
