#ifndef REMOTECLIENTMANAGER_H
#define REMOTECLIENTMANAGER_H

#include <QObject>
#include <QStringList>
#include <QList>
#include <QHash>

#include "lwclient.h"
#include "settings.h"

class RemoteClientManager : public QObject
{
    Q_OBJECT

public:
    RemoteClientManager();

	QStringList getDrives() { return drives; }
	QStringList getNames() { return names; }

	static QStringList getUsedLogicalDrives();
	static QString getAvailableLogicalDrive();
	static void removeRemoteDrive(QString drive);
	static QString appendRemoteDrive(QString name , QString _drive = QString());
	static void setRemoteDrives(QStringList *names, QStringList *drives, QList<bool> * remove, QHash<QString,QString> assignedDrives);
	static void setSharedFoldersDrives(QStringList *names, QStringList *drives, QList<bool> * remove, QHash<QString,QString> assignedDrives);
	static void setHomeDrive(QStringList * names, QStringList * drives, QList<bool> *remove);

public slots:
    void start();
    void stop();

signals:
    void update();

private:
    QStringList drives;
    QStringList names;
    QList<bool> remove;
};

#endif // REMOTECLIENTMANAGER_H
