#include "systrayclient.h"

SystrayClient::SystrayClient(HWND winId, QWidget * parent) : QWidget( parent )
{
	setAttribute( Qt::WA_NativeWindow, true );
	setFixedSize( SYSTRAY_ICON_SIZE, SYSTRAY_ICON_SIZE );
	_winId = winId;

	layout = new QVBoxLayout;
	layout->setMargin(0);
	layout->setSpacing(0);
	setLayout( layout );
	_window = QWindow::fromWinId( (long long)_winId );
	_widget = QWidget::createWindowContainer( _window, 0, Qt::ForeignWindow );
	_widget->setFixedSize( SYSTRAY_ICON_SIZE, SYSTRAY_ICON_SIZE );
	layout->addWidget( _widget, 1, Qt::AlignHCenter | Qt::AlignVCenter);
}

SystrayClient::~SystrayClient()
{
	delete _window;
	delete _widget;
	delete layout;
}

void SystrayClient::refresh()
{
	_widget->hide();
	qApp->processEvents();
	_widget->show();
}

void SystrayClient::paintEvent(QPaintEvent * paintEvent)
{
	QWidget::paintEvent( paintEvent );
}

bool SystrayClient::nativeEvent(const QByteArray &eventType, void *message, long *result)
{
	return QWidget::nativeEvent( eventType, message, result );
}
