#ifndef SYSTRAYCLIENT_H
#define SYSTRAYCLIENT_H

#include <QWidget>
#include <QWindow>
#include <QVBoxLayout>
#include <QPaintEvent>
#include <QApplication>
#include <QTimer>
#include <QMutex>

#include "constants.h"
#include "wininfo.h"

class SystrayClient : public QWidget
{
	Q_OBJECT
public:
	explicit SystrayClient(HWND winId, QWidget *parent = 0);
	~SystrayClient();

	QWidget * widget() { return _widget; };
	QWindow * window() { return _window; };

public slots:
	void refresh();

protected:
	void paintEvent(QPaintEvent * paintEvent);
	bool nativeEvent(const QByteArray &eventType, void *message, long *result);

private:
	HWND _winId;
	QWidget * _widget;
	QWindow * _window;
	QVBoxLayout * layout;
};

#endif // SYSTRAYCLIENT_H
