#ifndef SYSTRAYWIDGET_H
#define SYSTRAYWIDGET_H

#include <QWidget>
#include <QWindow>
#include <QHBoxLayout>
#include <QMap>
#include <QTimer>
#include <QPushButton>

#include "systraymanager.h"
#include "systrayclient.h"
#include "wininfo.h"
#include "settings.h"

class SystrayWidget : public QWidget
{
	Q_OBJECT
public:
	explicit SystrayWidget(QWidget *parent = nullptr);
	~SystrayWidget();

signals:

public slots:
	void addIcon(HWND winId);
	void removeIcon(HWND winId);
	void updateIcons();
	void removeLayout();
	void checkSystray();

protected:
	void childEvent(QChildEvent *event);

private:
	SystrayManager * systrayManager;
	QHBoxLayout * layout;
	QMap<HWND,SystrayClient*> icons;
	QList<HWND> iconsWindowList;
	QList<QImage> iconsWindowListImages;
	QList<HWND> invalidWindowList;
	QMutex mutex;
	QMutex addIconMutex;
	QTimer * timer;
};

#endif // SYSTRAYWIDGET_H
