#ifndef TABLEWIDGET_H
#define TABLEWIDGET_H

#include <QWidget>
#include <QGridLayout>

#include "pixmapframe.h"

class TableWidget : public QWidget
{
	Q_OBJECT

public:
	TableWidget(QWidget *parent = 0);

	void clear();
	void addWidget(QWidget * widget, int row, int col);
	void addMultiCellWidget( QWidget * widget, int xPos, int yPos, int numRows, int numCols );
	void removeWidget( QWidget * w );
	QWidget * widgetAtPosition( int row, int col );
	void removeItemAtPosition(int row, int col);
	void addItem(QLayoutItem * item , int row, int col);
	void prepareCells(int numberOfApps = 0);
	int getColumns() { return columns; };
	int getRows() { return rows; };
	bool isEmpty(int row, int column);

private:
	void createLayout();

signals:
	void mousePressed();

protected:
	void mousePressEvent(QMouseEvent *event);

private:
	QGridLayout * layout;
	int rows;
	int columns;
	QString color;
	QString fontcolor;
};

#endif // TABLEWIDGET_H
