#ifndef THREADWIDGET_H
#define THREADWIDGET_H

#include "threadbutton.h"

#include <QFrame>
#include <QLabel>
#include <QProcess>
#include <QIcon>
#include <QGridLayout>

/*
#ifdef Q_OS_LINUX
#include "x11info.h"
#endif
*/

#include "closebutton.h"
#include "constants.h"
#include "threadbutton.h"

class ThreadWidget : public QFrame
{
	Q_OBJECT

	public:
		ThreadWidget( QWidget * parent = 0, bool forThreadManager = false );

		ThreadButton * getThreadButton();

	public slots:
		void setThreadButton(ThreadButton * threadButton);
		void closeButtonClickedSlot();
		void killButtonClickedSlot();
        void setName( QString threadName );
        void setText( QString threadText );

	signals:
		void closeButtonClicked(ThreadButton *);
		void killButtonClicked(ThreadButton *);
		void clicked(ThreadButton *);

	private slots:
		void clicked();

	private:
		long window;

		QGridLayout * layout;
		QLabel * name;
		QLabel * text;
		QLabel * statusLabel;
		QPushButton * previewButton;
		QLabel * preview;
		CloseButton * closeButton;
		CloseButton * killButton;
        ThreadButton * threadButton;
		bool forThreadManager;
};

#endif
