#ifndef USERCONFIG_H
#define USERCONFIG_H

#include <QObject>

#ifdef Q_OS_WIN
#include <WinSock2.h>
#include <Windows.h>
#include <lm.h>
#endif

#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QLineEdit>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QDir>
#include <QLabel>
#include <QMessageBox>

#include "configurationdialog.h"
#include "toolbutton.h"
#include "settings.h"

class UserConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		UserConfig(QWidget * parent);

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "userconfig.png"); };
		QString name() { return tr("User Configuration"); };
		QDialog * widget() { return this; };


	public slots:
		void accept();
		void reject();

	private:
		QGridLayout * layout;

		QLineEdit * username;
		QLineEdit * password;
		QLineEdit * newPassword;
		QLineEdit * repeatPassword;
		QPushButton * acceptButton;
		QPushButton * cancelButton;
};

#endif
