#ifndef TESTMANAGER_H
#define TESTMANAGER_H

#include <QThread>
#include <QObject>
#include <QMutex>
#include <QListWidget>
#include <QListWidgetItem>
#include <QLabel>

#ifdef Q_OS_LINUX
#include <QX11Info>
#endif

#ifdef Q_OS_WIN
#include <WinSock2.h>
#include <windows.h>
#include <Psapi.h>
#include <lm.h>
#include <WtsApi32.h>
#include <QtWinExtras/QtWin>
#endif

#include "../common/wininfo.h"
#include "../common/winaction.h"
//#include "constants.h"

//Q_DECLARE_METATYPE(QList<long long>)

class TestManager : public QThread
{
	Q_OBJECT

	public:
		TestManager( QListWidget * widget, QObject * parent = Q_NULLPTR );

		void run();
		void stop();

		void setDockBar( HWND id );
		void setDesktop( HWND id );

	private:
		bool keepRunning;
		QMutex mutex;
		QListWidget * widget;
};

#endif
