#include "childframe.h"

ChildFrame::ChildFrame(QWidget *parent) : QFrame(parent)
{
	radius = 0;
}

void ChildFrame::setPixmap(QPixmap pixmap)
{
	this->pixmap = pixmap;
}

void ChildFrame::paintEvent(QPaintEvent *)
{
	if ( ! pixmap.isNull() )
	{
		QPainter painter(this);
		painter.drawPixmap( rect(), pixmap );
	}
	roundCorners();
}

void ChildFrame::setRadius(int radius)
{
	this->radius = radius;
}

void ChildFrame::roundCorners()
{
	if ( radius != 0 )
	{
		QPixmap px(size()); //Create pixmap with the same size of current widget
		px.fill(Qt::transparent); //Fill transparent
		QPainter p(&px);
		QBrush brush;
		brush.setStyle(Qt::SolidPattern); //For fill
		p.setBrush(brush);
		p.drawRoundedRect(rect(), radius, radius); //Draw filled rounded rectangle on pixmap
		setMask(px.mask()); //The the mask for current widget.
	}
}
